#ifndef CONFIG_H_
#define CONFIG_H_

#include <limits.h>

typedef struct config_settings_s {
	char audiopath[PATH_MAX];
	char videopath[PATH_MAX];
	char picturepath[PATH_MAX];
	char persistentstoragepath[PATH_MAX];
	char kmlurl[PATH_MAX];
	char pretrigger[PATH_MAX];
	char posttrigger[PATH_MAX];
	char audiofileextensions[255];
	char videofileextensions[255];
	char picturefileextensions[255];
	char isofileextensions[255];
	int max_recent_files;
	char server_character_set[64];
	char client_character_set[64];
	char subtitle_catchall_pattern[PATH_MAX];
	int picturetargetwidth;
	int picturetargetheight;
	int picturemaxzoompercent;
	int picturecachesize;
	int picturecachetrimminginterval;
	int networktimeoutinterval;
	char enablehiddenfilestext[128];
	int enablehiddenfilesminutes;
} config_settings_t;

extern config_settings_t config;

int parse_config(config_settings_t *config_p);
void show_current_config_Verbose(const config_settings_t *config_p);

#endif /*CONFIG_H_*/
