#ifndef UTILS_H_
#define UTILS_H_

#include <sys/stat.h>


enum convertdirection_t {cdt_from_client=0, cdt_to_client};


/* Prototypes of public functions */

const char* convert_charset(const char* s, enum convertdirection_t direction);
void make_lowercase(char *buf);
const char* list_pointer(const char *haystack, const char *needle, const char *delimiters);
int list_contains(const char *haystack, const char *needle, const char *delimiters);
int list_contains_extension(const char *list, const char *filename);
int string_substitute(char *haystack, const char *needle, const char *substitution, int haystack_size);
int casestat(char *filename, struct stat *statbuf);
int my_filelist_compare(const void *ap, const void *bp);
int get_recent_path(char *recentpath, const char *mediapath);
void clean_pathname(char *pathname);
int verify_path(char *p);
int construct_pseudo_name(const char* prefix, char** thisname_p, int fullpath_len);


#endif /*UTILS_H_*/
